//
//  RootViewController.m
//  SimpleXMLRPC
//
//  Created by Markus Hutzler on 10/7/11.
//  Copyright 2011 spiderware gmbh. All rights reserved.
//

#import "RootViewController.h"

@implementation RootViewController

- (void)viewDidLoad
{
    [super viewDidLoad];
    
    // generating test content
    
    remotes = [[NSMutableArray alloc] init];
    locales = [[NSMutableArray alloc] init];
    
    [locales addObject:@"test_f"];
    [locales addObject:@"text"];
    
    [remotes addObject:[NSArray arrayWithObjects:
                        @"http://markus5.ch/wordpress/xmlrpc.php", 
                        @"inPlace.ping",
                        [NSArray arrayWithObjects:    
                         @"1",
                         @"USER",
                         @"PASS", 
                         nil],
                        nil]];
    
    [remotes addObject:[NSArray arrayWithObjects:
                        @"http://www.google.com", 
                        @"nothing.ping",
                        [NSArray arrayWithObjects:    
                         @"1",
                         nil],
                        nil]];
    
    [remotes addObject:[NSArray arrayWithObjects:
                        @"http://markus5.ch/wordpress/xmlrpc.php", 
                        @"inPlace.info",
                        [NSArray arrayWithObjects:    
                         @"location",
                         nil],
                        nil]];
    
    [remotes addObject:[NSArray arrayWithObjects:
                        @"http://markus5.ch/wordpress/xmlrpc.php", 
                        @"inPlace.info",
                        [NSArray arrayWithObjects:    
                         @"location",[NSNumber numberWithBool:NO],[NSNumber numberWithInt:467],[NSNumber numberWithDouble:67.5465],//[UIImage imageNamed:@"People.png"],//UIImagePNGRepresentation([UIImage imageNamed:@"People.png"]),
                         nil],
                        nil]];
    
}

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
}

- (void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
}

- (void)viewWillDisappear:(BOOL)animated
{
	[super viewWillDisappear:animated];
}

- (void)viewDidDisappear:(BOOL)animated
{
	[super viewDidDisappear:animated];
}



/*
 // Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
	// Return YES for supported orientations.
	return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
 */

// Customize the number of sections in the table view.
- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    return 2;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    if (section == 0)
        return [locales count];
    else if (section == 1)
        return [remotes count];
    return 0;
}

// Customize the appearance of table view cells.
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *CellIdentifier = @"Cell";
    
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleSubtitle reuseIdentifier:CellIdentifier] autorelease];
    }
    if (indexPath.section == 0) {
        cell.textLabel.text = [locales objectAtIndex:indexPath.row];
    }
    else if (indexPath.section == 1) {
        cell.textLabel.text = [[remotes objectAtIndex:indexPath.row] objectAtIndex:0];
        cell.detailTextLabel.text = [[remotes objectAtIndex:indexPath.row] objectAtIndex:1];
    }
    // Configure the cell.
    return cell;
}

-(NSString *)tableView:(UITableView *)tableView titleForHeaderInSection:(NSInteger)section
{
    if (section == 0)
        return @"Local Parse";
    else if (section == 1)
        return @"Remote Parse";
    return @"";
}

/*
// Override to support conditional editing of the table view.
- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Return NO if you do not want the specified item to be editable.
    return YES;
}
*/

/*
// Override to support editing the table view.
- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath
{
    if (editingStyle == UITableViewCellEditingStyleDelete)
    {
        // Delete the row from the data source.
        [tableView deleteRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:UITableViewRowAnimationFade];
    }
    else if (editingStyle == UITableViewCellEditingStyleInsert)
    {
        // Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view.
    }   
}
*/

/*
// Override to support rearranging the table view.
- (void)tableView:(UITableView *)tableView moveRowAtIndexPath:(NSIndexPath *)fromIndexPath toIndexPath:(NSIndexPath *)toIndexPath
{
}
*/

/*
// Override to support conditional rearranging of the table view.
- (BOOL)tableView:(UITableView *)tableView canMoveRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Return NO if you do not want the item to be re-orderable.
    return YES;
}
*/

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    SimpleXMLRPC * test;
    if (indexPath.section == 0)
    {
        NSString *filePath = [[NSBundle mainBundle] pathForResource:[locales objectAtIndex:indexPath.row] ofType:@"xml"];  
        if (filePath) {  
            NSString *myText = [NSString stringWithContentsOfFile:filePath encoding:NSUTF8StringEncoding error:nil];  
            NSLog(@"%@",myText); 
            test = [[SimpleXMLRPC alloc] initWithString:myText delegate:self]; 
        }
    } 
    else if (indexPath.section == 1)
    {
        test = [[SimpleXMLRPC alloc] initWithURL:[NSURL URLWithString:[[remotes objectAtIndex:indexPath.row] objectAtIndex:0]] 
                                 function:[[remotes objectAtIndex:indexPath.row] objectAtIndex:1]  
                                     data:[[remotes objectAtIndex:indexPath.row] objectAtIndex:2] 
                                 delegate:self];
    }
    
    
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Relinquish ownership any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload
{
    [super viewDidUnload];

    // Relinquish ownership of anything that can be recreated in viewDidLoad or on demand.
    // For example: self.myOutlet = nil;
}

- (void)dealloc
{
    [super dealloc];
}

#pragma mark - SimpleXMLRPC Delegates

-(void)simpleXMLRPC:(SimpleXMLRPC *)d didFinishWithData:(id)data
{
    // The server responded with success
    NSLog(@"simpleXMLRPC:didFinishWithData: %@ %@",[data description],[d description]);
    
    // release your instance here. After this delegate no the SimpleXMLRPC will not be used anymore.
    [d release];
}

-(void)simpleXMLRPC:(SimpleXMLRPC *)d didFailWithData:(id)data
{
    // The server responded with an error
    NSLog(@"simpleXMLRPC:didFailWithData: %@",[data description]);
    
    // release your instance here. After this delegate no the SimpleXMLRPC will not be used anymore.
    [d release];
}

-(void)simpleXMLRPC:(SimpleXMLRPC *)d didFailWithError:(NSError *)error
{
    // There was an error calling the remote location... See what hapend in the error instance.
    
    NSLog(@"simpleXMLRPC:didFailWithError: %@: %@",[error domain],[error localizedDescription]);
    //Use [[error userInfo] objectForKey:@"reason"] to debug the XML-File.
    NSLog(@"\n%@",[[error userInfo] objectForKey:@"reason"]);
    
    // release your instance here. After this delegate no the SimpleXMLRPC will not be used anymore.
    [d release];
    
}

@end
